//---- ПОДКЛЮЧЕНИЕ БИБЛИОТЕК
#include "RT_HW_Main.h"
//--------------------------------------------------------
//    СОЗДАНИЕ ОБЪЕКТОВ И ПЕРЕМЕННЫХ ДЛЯ РАБОТЫ С НИМИ
//--------------------------------------------------------
RT_HW_PIN_DIGITAL_ID  idControl,  idFast,  idSlow,  idBack,  idTest1,  idTest2,  idTest3,  idTest4,  idLife,  idDebug;
int                  pinControl, pinFast, pinSlow, pinBack, pinTest1, pinTest2, pinTest3, pinTest4, pinLife, pinDebug;
int pinSR04, pinSR04t, pinDHT;
uint8_t taskPrintParam=0;   //--рабочий параметр для однократной инициализации параметров
uint8_t cntHeadNum;         //--текущий номер заголовка
//--------------------------------------------------------
//    ОБЪЕКТЫ ГЕНЕРАТОРЫ ЗАДАЧ
//--------------------------------------------------------
RT_HW_TASK_GENERATOR_ID EventFast, EventSlow, EventBack; 
RT_HW_TASK_GENERATOR_ID EventLife, EventLcd,  EventHead; 
//--------------------------------------------------------
//   ПРЕД-ОПРЕДЕЛЕНИЕ ФУНКЦИЙ
//--------------------------------------------------------
void initParam(); 
void paramToConsole();
//===========================================================
void setup() {} //--end setup()
//===========================================================
void loop() {
//--------- ИНИЦИАЛИЗАЦИЯ ПАРАМЕТРОВ И ОБОРУДОВАНИЯ ---------
if(!RT_HW_Board.init) {
  RT_HW_Board.init=true;
  initParam();            //--НАСТРОЙКА ПАРАМЕТРОВ ПОД ИСПОЛЬЗУЕМЫЙ КОНТРОЛЛЕР
                          //--Здесь можно переустановить параметры
} //--end if(!RT_HW_Board.init)
//--------- ДИСПЕТЧЕР ЗАДАЧ----(библиотечные значения: Fast=25mcs, Slow=100mcs) 
if(!RT_HW_Task.init) {RT_HW_Task.setPeriodFast(10); RT_HW_Task.setPeriodSlow(100);} //--Установка параметров диспетчера задач
RT_HW_Task.run();                                   //--Вызов диспетчера задач 
RT_HW_Task.generator(EventFast,RT_HW_Task.fast,  4);  //--Генерация номеров четырех быстрых задач
RT_HW_Task.generator(EventSlow,RT_HW_Task.slow,  4);  //--Генерация номеров четырех медленных задач
RT_HW_Task.generator(EventBack,RT_HW_Task.back,  5);  //--Генерация номеров четырех фоновых задач
RT_HW_Task.generator(EventLcd, EventBack.task==2,8);  //--Генерация 8 номеров задачи управления Lcd внутри фоновой задачи 2
//--------- Вывод контрольных точек ДИСПЕТЧЕРА ЗАДАЧ при их изменении
RT_HW_Board.pinDigitalWriteID(idControl,pinControl,RT_HW_Task.control); 
RT_HW_Board.pinDigitalWriteID(idFast,   pinFast,  RT_HW_Task.fast); 
RT_HW_Board.pinDigitalWriteID(idSlow,   pinSlow,  RT_HW_Task.slow); 
RT_HW_Board.pinDigitalWriteID(idBack,   pinBack,  EventBack.task==1   ? true : false); 

RT_HW_Board.pinDigitalWriteID(idTest1,  pinTest1, RT_HW_Task.fast10); 
RT_HW_Board.pinDigitalWriteID(idTest2,  pinTest2, RT_HW_Task.back100);  
RT_HW_Board.pinDigitalWriteID(idTest3,  pinTest3, EventHead.task==1   ? true : false); 
RT_HW_Board.pinDigitalWriteID(idTest4,  pinTest4, EventLcd.task==2    ? true : false);  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//-------- Фоновая задача - вызывается каждые 100 ms ------------------------------------
if(RT_HW_Task.back100){
 //--------Изменение cntHeadNum каждые 3 сек
  RT_HW_Task.generator(EventHead, true, 30);   
  if(EventHead.event) {cntHeadNum++; if(cntHeadNum>3) cntHeadNum=0; RT_HW_String.consoleInt16 (cntHeadNum,"Номер заголовка= ");}
  //--------
  RT_HW_Task.generator(EventLife, true,6,4);  //--Сигнал "живучесть" - период=RT_HW_Task.periodFast*6; режим On=RT_HW_Task.periodFast*6
  RT_HW_Board.pinDigitalWriteID(idLife,pinLife, EventLife.pulse); 
   //--------
  RT_HW_String.consoleBegin(115200);
  if(RT_HW_String.console && (taskPrintParam==0)){taskPrintParam=1;}
  //--------
} //end if(RT_HW_Task.back100)
//------- Однократный вывод на консоль конфигурации системы
if(taskPrintParam==1){
  taskPrintParam=2;
   //--------- ВЫДАЧА ПАРАМЕТРОВ НАСТРОЙКИ В СИСТЕМНЫЙ ПОРТ
RT_HW_String.consoleString(RT_HW_Board.name,"Имя платы= "); 
RT_HW_String.consoleInt16 (RT_HW_Board.code,"Код платы= ");
RT_HW_String.consoleInt16 (RT_HW_Board.ledControl, "Пин контрольного светодиода=");
RT_HW_String.consoleInt16 (RT_HW_Board.digitalPins,"Кол-во дискретных пинов=");
RT_HW_String.consoleInt16 (RT_HW_Board.analogPins, "Кол-во аналоговых пинов="); 
RT_HW_String.consoleString(RT_HW_String.packFourFloat (pinControl,       pinFast,          pinSlow,              pinBack,              'R',5), String(F("пины :: cnt___fast__slow__back ->")));
RT_HW_String.consoleString(RT_HW_String.packFourFloat (pinTest1,         pinTest2,         pinTest3,             pinTest4,             'R',5), String(F("пины :: test1_test2_test3_test4->")));
RT_HW_String.consoleString(RT_HW_String.packFourFloat (pinLife,          pinSR04 ,         pinDHT,               pinDebug,             'R',5), String(F("пины :: life__sr04__dht___debug->")));
RT_HW_String.consoleString(String(F("---------------------------------------------------------------------")));
}  
//------- Быстрая задача с номером 1 ------------------------------------- 
if(EventFast.task=1){}
//------- Медленная задача с номером 2 ----------------------------------- 
if(EventSlow.task=2){}
//------- Задача управления Lcd с номером 1 внутри фоновой задачи 2------- 
if(EventLcd.task=3){}
//------- Фоновая задача с номером 3 -------------------------------------
if(EventBack.task==3){}
//------------------------------------------------------------------------
} //--end loop()
//=========================================================================
//--------- УСТАНОВКА ПАРАМЕТРОВ ПОД ИСПОЛЬЗУЕМЫЙ КОНТРОЛЛЕРА ---------
void initParam(){
                                           pinControl=-1; pinFast=-1; pinSlow=-1; pinBack=-1; pinLife=-1; pinSR04=-1, pinDHT=-1, pinDebug=-1; 
                                           pinTest1=-1; pinTest2=-1; pinTest3=-1; pinTest4=-1;   
 if(RT_HW_Board.code==RT_HW_CODE_AVR328)  {pinControl=14; pinFast=15; pinSlow=16; pinBack=17; pinLife=12, pinSR04= 2, pinDHT= 3, pinDebug=-1;}
 if(RT_HW_Board.code==RT_HW_CODE_MEGA2560){pinControl=38; pinFast=39; pinSlow=40; pinBack=41; pinLife=36; pinSR04= 2, pinDHT= 3, pinDebug=37;}
 if(RT_HW_Board.code==RT_HW_CODE_SAM3X8E) {pinControl=38; pinFast=39; pinSlow=40; pinBack=41; pinLife=36; pinSR04= 2, pinDHT= 3, pinDebug=37;}
 if(RT_HW_Board.code==RT_HW_CODE_ESP8266) {pinControl=15; pinFast=-1; pinSlow=-1; pinBack=-1; pinLife=13; pinSR04=14, pinDHT= 2, pinDebug=-1;}
 if(RT_HW_Board.code==RT_HW_CODE_ESP32)   {pinControl=32; pinFast=33; pinSlow=27; pinBack=19; pinLife=23; pinSR04=25, pinDHT=27, pinDebug=-1;}
 if(RT_HW_Board.code==RT_HW_CODE_STM32)   {pinControl= 0; pinFast= 1; pinSlow= 2; pinBack= 3; pinLife=32; pinSR04=28, pinDHT=26, pinDebug=-1;} 

 if(RT_HW_Board.code==RT_HW_CODE_AVR328)  {pinTest1= 8; pinTest2= 9; pinTest3=10; pinTest4=11;}
 if(RT_HW_Board.code==RT_HW_CODE_MEGA2560){pinTest1=42; pinTest2=43; pinTest3=44; pinTest4=45;}
 if(RT_HW_Board.code==RT_HW_CODE_SAM3X8E) {pinTest1=42; pinTest2=43; pinTest3=44; pinTest4=45;}
 if(RT_HW_Board.code==RT_HW_CODE_ESP8266) {pinTest1=-1; pinTest2=-1; pinTest3=-1; pinTest4=-1;}
 if(RT_HW_Board.code==RT_HW_CODE_ESP32)   {pinTest1=-1; pinTest2=-1; pinTest3=-1; pinTest4=-1;}
 if(RT_HW_Board.code==RT_HW_CODE_STM32)   {pinTest1= 4; pinTest2= 5; pinTest3= 6; pinTest4= 7;} 
};//--end initParam()  
//======================================================================  
