#include "RT_HW_Main.h"
/****************************************************************************************
 							 BOARD 
****************************************************************************************/
//---------------------------------------------------------------------------------------
//                 			КОНСТРУКТОР
//---------------------------------------------------------------------------------------
RT_HW_BOARD:: RT_HW_BOARD(){ 
code=		RT_HW_CODE_BOARD; 		//--Код платы 
name=		RT_HW_NAME_BOARD;		//--Имя платы
ledControl=	RT_HW_LED_BUILTIN;		//--Номер пина контрольного светодиода
digitalPins=RT_HW_NUM_DIGITAL_PINS;	//--Кол-во цифровых пинов
analogPins= RT_HW_NUM_ANALOG_PINS;	//--Кол-во аналоговых пинов
init=user=true; 
};	
//-------------------------------------------------------------------------------------------------
//       ФУНКЦИИ ДЛЯ ПРЯМОЙ РАБОТЫ С ПИНАМИ - если пин <0, действия не производятся
//-------------------------------------------------------------------------------------------------
bool 	 RT_HW_BOARD:: pinCheckDigital(int16_t pin)				{if(pin<0) return 0; return 1;}; //--Проверка дискретного пина на допустимость		    
bool 	 RT_HW_BOARD:: pinCheckAnalog (int16_t pin)				{if(pin<0) return 0; return 1;}; //--Проверка аналового   пина на допустимость

bool 	 RT_HW_BOARD:: pinModeOUTPUT  (int16_t pin)				{if(pinCheckDigital(pin)) {pinMode(pin,OUTPUT); 	  return 1;} return 0;}; //--Настройка пина на вывод

bool	 RT_HW_BOARD:: pinModeINPUT	  (int16_t pin)				{if(pinCheckDigital(pin)) {pinMode(pin,INPUT);  	  return 1;} return 0;}; //--Настройка пина на ввод
bool	 RT_HW_BOARD:: pinModeINPUT_PULLUP(int16_t pin) 		{if(pinCheckDigital(pin)) {pinMode(pin,INPUT_PULLUP); return 1;} return 0;}; //--Настройка пина на ввод с подтяжкой на HIGH 

bool 	 RT_HW_BOARD:: pinDigitalWrite(int16_t pin,bool val)	{if(pinCheckDigital(pin)) {digitalWrite(pin,val);     return 1;} return 0;}  //--Дискретный вывод (пин должен быть настроен на вывод)	
bool 	 RT_HW_BOARD:: pinDigitalOut  (int16_t pin,bool val)	{if(pinCheckDigital(pin)) {digitalWrite(pin,val); pinMode(pin,OUTPUT); return 1;} return 0;}  //--Дискретный вывод (вместе с настройкой пина) 	
bool 	 RT_HW_BOARD:: pinDigitalRead (int16_t pin)				{if(pinCheckDigital(pin)) {digitalRead(pin);      	  return 1;} return 0;}	 //--Дискретный ввод

//-------------------------------------------------------------------------------------------------
//       ФУНКЦИИ ЧТЕНИЕ АНАЛОГОВО ВХОДА - если пин <0, действия не производятся
//-------------------------------------------------------------------------------------------------
uint16_t RT_HW_BOARD:: pinAnalogRead  (int16_t pin)				{
	if(pinCheckAnalog (pin)) {analogRead(pin);       	  return 1;} return 0;
	}	 //--Аналоговый ввод
//-------------------------------------------------------------------------------------------------
//       АНАЛОГОВЫЙ ВЫВОД (в работе - нужно подобрать концепцию)
//------------------------------------------------------------------------------------------------
bool	 RT_HW_BOARD:: pinAnalogWrite (int16_t pin,uint16_t val){if(pinCheckAnalog (pin)) {
// здесь должен появиться код 
	return 0;}	
return 1;}; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			КЛАСС RT_HW_PIN_DIGITAL_ID - ДЛЯ РАБОТЫ С ФУНЦИЯМИ BOARD: pinDigitalWriteID	
// init - флаг инициализации пина
// dOutYes:	- c пином можно работать как с дискретным выводом - 
//        устанавливается при инициализации и зависит от типа контроллера; (!!! можно доработать эту часть до таблицы разрешенных пинов)
// dOutAll: - разрешен вывод в каждом цикле. Иначе только первый раз и далее при изменения записываемого значения. default=0;
// dOutAgo: - последнее записанное значение
// dOutInv: - флаг инверсии вывода
// dOutRun: - флаг запуска вывода
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void	RT_HW_BOARD:: pinDigitalWriteID		   (RT_HW_PIN_DIGITAL_ID &id, int16_t pin, bool val){
		if(id.dOutYes) {id.dOutRun=false; if(id.dOutAll) {id.dOutRun=true;} else { if(id.dOutAgo!=val) {id.dOutAgo=val; id.dOutRun=true;}}}
				else   {if(!id.init) {if(pinCheckDigital(pin))  {id.dOutYes=id.dOutRun=true; pinMode(pin,OUTPUT);} else {id.dOutYes=false;} id.init=true;}}
		if(id.dOutRun)	{digitalWrite(pin,(id.dOutAgo xor id.dOutInv));} 
}
//---------------------------------------------------------------------------------------
//                           СОЗДАНИЕ ОБЪЕКТА 
//---------------------------------------------------------------------------------------
RT_HW_BOARD   RT_HW_Board;
//=======================================================================================



