/*** FLProg ************** Библиотека RT_HW_Main.h ver 2.1 для Arduino ***************
  Библиотеки серии RT состоит из различных библиотек, построенных по общим приницпам,
  для контролеров AVR, MEGA2560, SAM3XDUE, ESP8266, ESP32, STM32
  Библиотеки  разрабатываются с возможностью самостоятельного использования 
  и с учетом использования в системе визуального программирования FLProg.
  ecoins@mail.ru
  30.03.2019г.
**************************************************************************************************/
//#################################################################################################
#ifndef RT_HW_Main_h
#define RT_HW_Main_h

#if defined(ARDUINO) && ARDUINO >= 100 
#include <Arduino.h>
#else
#include <WProgram.h>
#endif
////--Номера версий библиотек
#define RT_HW_MAIN_VERSION		32		
#define RT_HW_BOARD_VERSION		31
#define RT_HW_STRING_VERSION	31
#define RT_HW_TASK_VERSION   	31
#define RT_HW_CONSOLE_VERSION   11
//---Макросы идентификации плат
#define RT_HW_DEFINED_AVR328   defined (__AVR_ATmega328__) || defined (__AVR_ATmega328P__) || defined(__AVR_ATmega168__) || defined(__AVR_ATmega88__)
#define RT_HW_DEFINED_MEGA2560 defined(__AVR_ATmega2560__) || defined(__AVR_ATmega2561__) 
#define RT_HW_DEFINED_SAM3X8E  defined(__SAM3X8E__)
#define RT_HW_DEFINED_ESP8266  defined(ESP8266) 
#define RT_HW_DEFINED_ESP32    defined(ESP32) 
#define RT_HW_DEFINED_STM32    defined(_VARIANT_ARDUINO_STM32_) 
#define RT_HW_DEFINED_ANON 				
//+++++++++++++++++ ВЫБОР ИНДИВИДУАЛЬНЫХ ПАРАМЕТРОВ ДЛЯ КОНТРОЛЛЕРОВ+++++++++++
//----Определение кодов плат для использования в библиотеках  и внешних программах 
enum { RT_HW_CODE_NO=0,      RT_HW_CODE_AVR328=1, RT_HW_CODE_MEGA2560=2, RT_HW_CODE_SAM3X8E=3, 
       RT_HW_CODE_ESP8266=4, RT_HW_CODE_ESP32=5,  RT_HW_CODE_STM32=6,    RT_HW_CODE_ANON=7};
//----------------- AVR ATmega328,328P,168,88 ---------------------------------
#if       RT_HW_DEFINED_AVR328
	#define RT_HW_NAME_BOARD		"AVR328"
	#define RT_HW_CODE_BOARD		RT_HW_CODE_AVR328
	#define RT_HW_LED_BUILTIN		13
	#define RT_HW_NUM_DIGITAL_PINS	20
	#define RT_HW_NUM_ANALOG_PINS	 8
	#define RT_HW_MODE_ANALOG_INPUT	INPUT;
//	#define RT_HW_MODE_DIGITAL_INPUT			INPUT;
//	#define RT_HW_MODE_DIGITAL_INPUT_HIGH		INPUT_PULLUP;
//	#define RT_HW_MODE_DIGITAL_INPUT_LOW		INPUT;
	
	#define RT_HW_PIN_MODE_OUTPUT					OUTPUT		//STM32F1 - GPIO_OUTPUT_PP; 		ESP32 0x02
	#define RT_HW_PIN_MODE_OUTPUT_OPEN_DRAIN		OUTPUT		//STM32F1 - GPIO_OUTPUT_OD;			0x10
	#define RT_HW_PIN_MODE_OUTPUT_PWM				OUTPUT		//STM32F1 - GPIO_AF_OUTPUT_PP;      ---
	#define RT_HW_PIN_MODE_OUTPUT_PWM_OPEN_DRAIN	OUTPUT		//STM32F1 - GPIO_AF_OUTPUT_OD;     ----
	
	#define RT_HW_PIN_MODE_INPUT				 	INPUT		//STM32F1 - GPIO_INPUT_FLOATING;    0x01
	#define RT_HW_PIN_MODE_INPUT_FLOATING			INPUT		//STM32F1 - GPIO_INPUT_FLOATING;    0x02
	#define RT_HW_PIN_MODE_INPUT_ANALOG				INPUT		//STM32F1 - GPIO_INPUT_ANALOG;
	#define RT_HW_PIN_MODE_INPUT_PULLUP				INPUT		//STM32F1 - GPIO_INPUT_PU;
	#define RT_HW_PIN_MODE_INPUT_PULLDOWN			INPUT		//STM32F1 - GPIO_INPUT_PD;

/* ESP32
#define INPUT             0x01
#define OUTPUT            0x02
#define PULLUP            0x04
#define INPUT_PULLUP      0x05
#define PULLDOWN          0x08
#define INPUT_PULLDOWN    0x09
#define OPEN_DRAIN        0x10
#define OUTPUT_OPEN_DRAIN 0x12
*/	

/* AVR
#define INPUT 0x0
#define OUTPUT 0x1
#define INPUT_PULLUP 0x2
*/

//----------------- AVR ATmega2560,256 -----------------------------------------	
  #elif     RT_HW_DEFINED_MEGA2560 
	#define RT_HW_NAME_BOARD		"MEGA2560"
	#define RT_HW_CODE_BOARD		RT_HW_CODE_MEGA2560	
   	#define RT_HW_LED_BUILTIN		13
	#define RT_HW_NUM_DIGITAL_PINS	54
	#define RT_HW_NUM_ANALOG_PINS	16
	#define RT_HW_MODE_ANALOG_INPUT	INPUT
//----------------- SAM32X8E DUE ----------------------------------------------
  #elif     RT_HW_DEFINED_SAM3X8E
	#define RT_HW_NAME_BOARD		"SAM3X8E"
	#define RT_HW_CODE_BOARD		RT_HW_CODE_SAM3X8E	
   	#define RT_HW_LED_BUILTIN		13
	#define RT_HW_NUM_DIGITAL_PINS	54
	#define RT_HW_NUM_ANALOG_PINS	16	
	#define RT_HW_MODE_ANALOG_INPUT	INPUT
//--------------- ESP8266 ----------------------------------------------------
  #elif     RT_HW_DEFINED_ESP8266
	#define RT_HW_NAME_BOARD		"ESP8266"	
	#define RT_HW_CODE_BOARD		RT_HW_CODE_ESP8266	
	#define RT_HW_LED_BUILTIN		 2
	#define RT_HW_NUM_DIGITAL_PINS	12
	#define RT_HW_NUM_ANALOG_PINS	 1	
	#define RT_HW_MODE_ANALOG_INPUT	INPUT
//----------------- ESP32 ------------------------------------------------------
  #elif 	RT_HW_DEFINED_ESP32
	#define RT_HW_NAME_BOARD		"ESP32"
	#define RT_HW_CODE_BOARD		RT_HW_CODE_ESP32
   	#define RT_HW_LED_BUILTIN		23	
	#define RT_HW_NUM_DIGITAL_PINS	34
	#define RT_HW_NUM_ANALOG_PINS	10
	#define RT_HW_MODE_ANALOG_INPUT	INPUT	
//----------------- STM32 ------------------------------------------------------
  #elif   RT_HW_DEFINED_STM32  
	#define RT_HW_NAME_BOARD		"STM32"
    #define RT_HW_CODE_BOARD		RT_HW_CODE_STM32
   	#define RT_HW_LED_BUILTIN		32
	#define RT_HW_NUM_DIGITAL_PINS	33
	#define RT_HW_NUM_ANALOG_PINS	10   
	#define RT_HW_MODE_ANALOG_INPUT	INPUT_ANALOG	
//----------------- NO_TYPE_CONTROLLER -----------------------------------------
  #else 
	#define RT_HW_NAME_BOARD		"ANON"
    #define RT_HW_CODE_BOARD		RT_HW_CODE_ANON
   	#define RT_HW_LED_BUILTIN		-1	
	#define RT_HW_NUM_DIGITAL_PINS	 0
	#define RT_HW_NUM_ANALOG_PINS	 0
	#define RT_HW_MODE_ANALOG_INPUT	INPUT	
#endif 

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//					ДЛЯ РАБОТЫ С КЛАССОМ RT_HW_BOARD.h
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//=======================================================================================
//			КЛАСС RT_HW_PIN_DIGITAL_ID 	- ДЛЯ РАБОТЫ С КЛАССОМ BOARD	
// init - флаг инициализации пина
// dOutYes:	- c пином можно работать как с дискретным выводом - устанавливается при инициализации и зависит от типа контроллера; (!!! предстоит доработать эту часть до таблицы пинов)
// dOutAll: - разрешен вывод в каждом цикле. Иначе только первый раз и далее при изменения записываемого значения. default=0;
// dOutAgo: - последнее записанное значение
// dOutInv: - флаг инверсии вывода
// dOutRun: - флаг запуска вывода
//=======================================================================================
class RT_HW_PIN_DIGITAL_ID{
public:	
uint8_t init:1, user:1, dOutYes:1, dOutAll:1, dOutInv:1, dOutRun:1, dOutAgo:1; //--
uint8_t step;
int16_t pin;
RT_HW_PIN_DIGITAL_ID(){init=user=dOutYes=dOutAll=dOutInv=dOutRun=dOutAgo=false; step=0; pin=-1;}};//--конец класса
//=======================================================================================			
//			КЛАСС RT_HW_PIN_ANALOG_ID 	- ДЛЯ РАБОТЫ С КЛАССОМ BOARD	
//=======================================================================================
class RT_HW_PIN_ANALOG_ID{
public:	
uint8_t init:1, user:1, yes:1, ago: 1;
int16_t pin;
uint16_t result;
RT_HW_PIN_ANALOG_ID(){pin=-1; init=yes=false;}; 	};//--конец класса
//=======================================================================================
// 			КЛАСС RT_HW_BOARD - ОСНОВНЫЕ ПАРАМЕТРЫ КОНТРОЛЛЕРА, ФУНКЦИИ ДЛЯ РАБОТЫ С ПИНАМИ 		
//=======================================================================================
#pragma pack(push, 4)			//--Установка выравнивания до 4 байт
class RT_HW_BOARD{
public:
//----- Данные -------------------------------------------
uint8_t	 init:1, user:1;
uint8_t	 code;   		//--код платы
String	 name;	 		//--имя платы
int16_t	 ledControl;	//--номер контрольного светодиода
uint8_t	 digitalPins, analogPins; //--кол-во дискретных и аналоговых пинов
//----- Методы --------------------------------------------
RT_HW_BOARD();											//--Конструктор
//---------Прямое управление пинами 
bool	 pinCheckDigital	(int16_t pin);				//--Проверка дискретного пина на допустимость            
bool	 pinCheckAnalog		(int16_t pin);				//--Проверка аналогового пина на допустимость
bool 	 pinModeOUTPUT		(int16_t pin);				//--Настройка пина на вывод
bool	 pinModeINPUT		(int16_t pin);				//--Настройка пина на ввод
bool	 pinModeINPUT_PULLUP(int16_t pin);				//--Настройка пина на ввод с подтяжкой к плюсу
bool	 pinDigitalWrite	(int16_t pin, bool val); 	//--Дискретный вывод (пин должен быть настроен на вывод) 
//--Дискретный вывод (пин должен быть настроен на вывод) 
bool	 pinDigitalOut		(int16_t pin, bool val); 	//--Дискретный вывод (вместе с настройкой пина) 
bool	 pinDigitalRead		(int16_t pin);  			//--Дискретный ввод
uint16_t pinAnalogRead  	(int16_t pin);				//--Аналоговый ввод 
bool	 pinAnalogWrite 	(int16_t pin,uint16_t val); //--Аналоговый вывод (в работе)
bool 	 initDigitalRead   (RT_HW_PIN_DIGITAL_ID &id, int16_t Pin, bool val=false); //--Настройка дискретного пина на ввод: val=1 -пин с подтягиванием 
bool 	 initDirectLed	   (RT_HW_PIN_DIGITAL_ID &id, int16_t Pin, bool val=false); //--Настройка дискретного пина
bool 	 initDirectPWM	   (RT_HW_PIN_DIGITAL_ID &id, int16_t Pin, bool val=false); //--Настройка дискретного пина   
bool 	 allDigitalWrite   (RT_HW_PIN_DIGITAL_ID &id, bool val=false); 			  //--Вывод на дискретный пин всегда
bool 	 newDigitalWrite   (RT_HW_PIN_DIGITAL_ID &id, bool val=false); 			  //--Вывод на дискретный пин только при изменении val
void	 pinDigitalWriteID (RT_HW_PIN_DIGITAL_ID &id, int16_t pin, bool val);	  //--Вывод на дискретный вывод с настройками объекта id.
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
};  //--конец класса
#pragma pack(pop)				//---Восстановление предыдущей настройки


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 							РАБОТА С КОНСОЛЬЮ 	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//---------------------------------------------------------------------------------------
//			КЛАСС ID ПАРАМЕТРОВ ДЛЯ ВЫВОДА ПЕРЕМЕННЫХ НА КОНСОЛЬ
//  init-инициализации параметров;                 
//  run=1: запуск вывода;
//  head=1; разрешение вывода заголовка.
//  point(0-3) -кол-во знаков после запятой для float; 
//  change=1; вывод только при изменении значения; 
//  cr=1: после вывода добавляется перевод строки и возврат каретки; 	
//  modeFormat: формат вывода-> ='D'-десятичный; ='H'-HEX-формат;         ='B'-BIN-двоичный; ='F'-float-плавающий;
//								='C'-один символ;='S'-String-вывод текста;='T'-время, впереди добавляется 0, если val<10;
//	 			для int16 ='0' -val десятичный;
//						  ='1' -val/10 -один знак после точки, ='2'val/100 -два знака после точки,='3'val/1000 -триодин знак после точки.
//              иначе формат вывода int16_t HEX-формат.
//---------------------------------------------------------------------------------------
#pragma pack(push, 4)			//--Установка выравнивания до 4 байт
class RT_HW_CONSOLE_ID{
public:
uint8_t init:1, run:1, head:1, finish:1, cr:1, change:1, point:2; //init-инициализации параметров; run -запуска вывода point -кол-во знаков после запятой для float; cr=1: после вывода добавляется перевод строки и возврат каретки; 	
char 	mode; 					//--Формат вывода:='D'-десятичный;='H'-HEX-формат;='B'-BIN-двоичный;='F'-float-плавающий;='C'-один символ;='S'-String-вывод текста;='T'-время, впереди добавляется 0, если val<10;
char	signFinish;				//--Добавляемое завершение(символ) после вывода  переменной
String	txtHead;				//--Добавляемый заголовок (текст)  перед выводом переменной
RT_HW_CONSOLE_ID(){init=run=false;}
};
#pragma pack(pop)				//---Восстановление предыдущей настройки
//---------------------------------------------------------------------------------------
//				КЛАСС ФУНКЦИЙ ДЛЯ РАБОТЫ С КОНСОЛЬЮ
//---------------------------------------------------------------------------------------
//#pragma pack(push, 4)			//--Установка выравнивания до 4 байт
class RT_HW_CONSOLE{
public:
uint8_t init:1, ok:1, user:1, step:3;
uint32_t consoleSpeed; 	//--скорость порта; 
RT_HW_CONSOLE(); 		//--конструктор;
bool	begin(uint32_t speed=115200); 						//--Инициализация консоли. Устанавливает скорость и возвращает console=1, когда консоль готова к работе 
bool	setID		(RT_HW_CONSOLE_ID &id, char mode='N', char change='@', String head="@",char finish='@', char cr='@'); 
void	setRun		(RT_HW_CONSOLE_ID &id) {id.run=true;};
bool 	print_int16 (RT_HW_CONSOLE_ID &id, int16_t val);	//--Вывод на консоль int16	
bool 	print_float (RT_HW_CONSOLE_ID &id, float   val);	//--Вывод на консоль float
bool 	print_String(RT_HW_CONSOLE_ID &id, String  val);  	//--Вывод на консоль строки	
bool 	printString (RT_HW_CONSOLE_ID &id, String  &val) {return print_String(id,val);};//--Вывод на консоль строки c косвенным указателем её адреса 
bool	print_char	(RT_HW_CONSOLE_ID &id, char	   val);	//--Вывод на консоль символа
};
//#pragma pack(pop)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 			КЛАСС RT_HW_STRING - ФУНКЦИИ ДЛЯ РАБОТЫ СО СТРОКАМИ		
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#pragma pack(push, 4)			//--Установка выравнивания до 4 байт
class RT_HW_STRING{
public:
//--Данные
uint8_t  consoleReady:1, consoleUser:1, consoleParam:1, consoleEvent:1, consoleStep:3;
uint32_t consoleTime, consoleWait;
uint32_t consoleSpeed; //--скорость порта
//--Методы
RT_HW_STRING(); 
//---Выбор параметров из строки по номеру параметра (параметры разделяются запятыми). Номера параметров начинаются с 1!!!
String   getString(String val, uint8_t n);  //--Возвращает строку (String). Если значения нет, возвращается пустая строка.
float	 getFloat (String val, uint8_t n);  //--Возвращает строку с float с двумя знаками после запятой. Если значения нет, возвращает NAN.
int16_t  getInt16 (String s,   uint8_t n);  //--Возвращает целое значение со знаком (int16_t). Если значения нет, возвращает -32768. 
char     getChar  (String val, uint8_t n);  //--Возвращает символ (char). Если значения нет, возвращает '*'.
int16_t  getPin   (String val, uint8_t n);	//--Возвращает номера пина. Если значения нет, возвращает -1.
int16_t  getDataFromString(String s,uint8_t n, char mode); //Возвращает номер пина или номер устройства. Если значения нет, возвращает -1.

//---Форматирование строковых переменных (возвращают строку длиной lеn с выравниванием)
String	 addBlank(uint8_t n);						            //--Возвращает строку с n пробелами
String	 formatString	(String  s,	uint8_t len=5, char a='L');	//--Строка с выравниванием влево
String   packFourFloat (float   v1=NAN, float   v2=NAN, float   v3=NAN, float   v4=NAN, char a='R', uint8_t len=5, uint8_t m=1); //--Строка с 4-мя float c m значений после запятой с выравниваем вправо. 	
String   packFourInt16 (int16_t v1=-1,  int16_t v2=-1,  int16_t v3=-1,  int16_t v4=-1,  char a='R', uint8_t len=3);	
String   packInt16(String head, char a,uint8_t len,uint8_t qnt,int16_t v1=-1,int16_t v2=-1,int16_t v3=-1,int16_t v4=-1,int16_t v5=-1,int16_t v6=-1,int16_t v7=-1,int16_t v8=-1); 
//-------Работа с консолью (особенно важно для STM32, DUE)
bool	 consoleBegin(uint32_t speed=115200); 							//--Инициализация консоли. Устанавливает скорость и возвращает console=1, когда консоль готова к работе 
bool 	 consoleString (String mess,String head=" ");  					//--Вывод на консоль строки			
bool 	 consoleInt16(int32_t val,String head=" ");						//--Вывод на консоль int16	
bool 	 consoleFloat  (float   val,String head=" ",uint8_t point=0);	//--Вывод на консоль float
//uint8_t  consolePrintParam(uint8_t &taskPrint, bool start);				//--Вывод на консоль строки	
char	bitToChar(bool in, char v1='_', char v2='+'){if(in) return v2; else return v1;}; //--Выбирает символ, в зависимости от входа

//bool     consolePtint(String head, String s,

};		//--конец класса
#pragma pack(pop)				//---Восстановление предыдущей настройки

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 			КЛАСС RT_HW_TASK.h - РАБОТА СО ВРЕМЕНЕМ И УПРАВЛЕНИЯ ЗАДАЧАМИ И СОБЫТИЯМИ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//=======================================================================================
// 							КЛАСС ОБЪЕКТА ДАННЫЕ
//=======================================================================================
#pragma pack(push, 4)			//--Установка выравнивания до 4 байт
class RT_HW_TASK_TIME_ID{
public:	
uint8_t init:1, user:1, run:1, mcs:1, busy:1, step:2;
uint32_t timeBegin;
RT_HW_TASK_TIME_ID(){step=0; run=false; init=user=true;};		}; //--конец класса
#pragma pack(pop)				//---Восстановление предыдущей настройки

//----------------------------------------------------------------------------------------
// 				КЛАСС ОБЪЕКТА ДЛЯ БЛОКОВ FLProg
//----------------------------------------------------------------------------------------
class RT_HW_TASK_FLPROG_ID{
public:	
uint8_t init:1,user:1;
RT_HW_TASK_FLPROG_ID(){init=user=false;};		}; //--конец класса
//----------------------------------------------------------------------------------------
// 				КЛАСС ОБЪЕКТА ФУНКЦИИ ДЛЯ ГЕНЕРАТОРА СОБЫТИЙ
//----------------------------------------------------------------------------------------
#pragma pack(push, 4)			//--Установка выравнивания до 4 байт
class RT_HW_TASK_GENERATOR_ID{
public:	
uint8_t work, task, agoTask;
uint8_t init:1,user:1, pulse:1, event:1, agoPulse:1, agoEvent:1;
RT_HW_TASK_GENERATOR_ID(){init=user=false;};		}; //--конец класса
#pragma pack(pop)				//---Восстановление предыдущей настройки
//----------------------------------------------------------------------------------------
// 							 КЛАСС ДАННЫХ ДЛЯ СЧЕТЧИКА int16_t
//----------------------------------------------------------------------------------------
#pragma pack(push, 4)			//--Установка выравнивания до 4 байт
class RT_HW_TASK_COUNTER_ID{
public:
uint8_t init:1, user:1, direct:1; 
char mode; 					//--'C' изменение дo -32868 или до +32867; 'L' изменение до top или bottom; 
							//  'S' пила до top или bottom с возвратом к нулю, 'T' треугольник между top и bottom
int16_t top, bottom, delta; //--нижняя,верхняя границы, шаг изменения;							
int32_t	cnt;				//--значение счетчика
RT_HW_TASK_COUNTER_ID(){init=user=false;}; //--конец класса
};
#pragma pack(pop)				//---Восстановление предыдущей настройки
//----------------------------------------------------------------------------------------
// 							 КЛАСС ФУНКЦИЙ ДИСПЕТЧЕРА ЗАДАЧ
//----------------------------------------------------------------------------------------
#pragma pack(push, 4)			//--Установка выравнивания до 4 байт
class RT_HW_TASK{
public:                      
//--Данные
uint8_t  init:1, user:1, begin:1, step:3, reset:1, permit:1, ok:1; 
uint8_t  control:1, fast10:1, fast:1, slow:1, back:1, back100:1, blink:1;
uint32_t timeBeginFast, timeBeginSlow, timeBeginFast10, timeBeginBack100;
uint32_t periodFast, periodSlow, t2, valWork;
//--Методы
RT_HW_TASK(); //--Конструктор
//---Функции работы со временем
uint32_t   getPastTense	(uint32_t &t1,uint32_t t2); 			//--Условие: t2>=t1; Возвращает разницу между t2-t1 с учетом переполнения //--
bool 	 checkPastTense (uint32_t &t1,uint32_t t2, uint32_t val);//-Возвращает true, если ((t2-t1) >= val)  
bool 	 checkPastMicros(uint32_t &t1,uint32_t val);			//--Возвращает true, если ((micros()-timeStart_mcs) >= val)
bool 	 checkPastMillis(uint32_t &t1,uint32_t val);			//--Возвращает true, если ((millis()-timeStart_ms)  >= val)
//---Функции фиксирующие изменения параметров
bool 	 changeByte	 (uint8_t  valAgo, uint8_t  val); 
bool 	 changeInt16 (uint16_t valAgo, uint16_t val);
bool 	 changeFloat (float    valAgo, float    val);
bool 	 changeString(String   valAgo, String   val);

//bool 	 checkPastTense (uint32_t &t1, uint32_t t2, uint32_t val);	//--Возвращает true, если ((t2-t1) >= val)  
//bool 	 checkPastMicros(uint32_t timeStart, uint32_t val);	//--Возвращает true, если ((t2-t1) >= val)  
//---Работа с диспетчером
bool 	 run();		 												//--Запуск диспетчера (рекомендуется помещать в начале loop()
void 	 setPeriodFast(uint16_t val) {periodFast=val*1000UL;}		//--Установка периода быстрых задач
void 	 setPeriodSlow(uint16_t val) {periodSlow=val*1000UL;}		//--Установка периода медленных задач
void 	 generator (RT_HW_TASK_GENERATOR_ID &id,bool ext,uint8_t qnt,uint8_t On=1); //--Генератор событий (bool,byte), импульсов
void	 makeBlink() {blink=!blink;};
bool 	 period    (RT_HW_TASK_TIME_ID      &id,uint32_t val=500,bool mcs=false);

//---Работа со счетчиком
void setCounterID(RT_HW_TASK_COUNTER_ID &id, char mode='T', int16_t delta=1, int16_t top=100, int16_t bottom=-100, int16_t begin=0);
void counter     (RT_HW_TASK_COUNTER_ID &id);						//--Счетчик int16
//-----
private:
}; //--конец класса
#pragma pack(pop)				//---Восстановление предыдущей настройки

/*
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 							 TIME	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class RT_HW_TIME {
public:
uint32_t getPastTense	 (uint32_t &t1,uint32_t t2);				//--измерение разницу времени (t2-t1) 
bool     checkPastTense	 (uint32_t &t1,uint32_t t2, uint32_t v);	//--событие, если ((t2-t1) >= val)
bool     eventMillis     (uint32_t &t1,uint32_t v);					//--событие с периодичностью val: рекомендуется инстал. t1=millis();
bool     eventMicros     (uint32_t &t1,uint32_t v);					//--событие с периодичностью val: рекомендуется инстал. t1=micros();
bool	 delayMicros	 (uint8_t  &s, uint32_t &t1, uint32_t v);	//--задержка длительностью   val(mcs)
bool	 delayMillis	 (uint8_t  &s, uint32_t &t1, uint32_t v);	//--задержка длительностью   val(ms)
bool     periodMillis    (uint8_t  &s, uint32_t &t1, uint32_t v);	//--событие с периодичностью val(ms)
bool     periodMicros    (uint8_t  &s, uint32_t &t1, uint32_t v);	//--событие с периодичностью val(mcs)
};
*/
//============Глобальные ссылки на созданные объекты	
extern RT_HW_BOARD		RT_HW_Board;	//----Глобальная ссылка на созданный объект RT_HW_Board
extern RT_HW_CONSOLE  	RT_HW_Console;
extern RT_HW_STRING 	RT_HW_String;
extern RT_HW_TASK   	RT_HW_Task;
//#################################################################################################
#endif //END #ifndef RT_HW_Main_h

//GPIO FUNCTIONS ESP3232

/*
#define INPUT             0x01
#define OUTPUT            0x02
#define PULLUP            0x04
#define INPUT_PULLUP      0x05
#define PULLDOWN          0x08
#define INPUT_PULLDOWN    0x09
#define OPEN_DRAIN        0x10
#define OUTPUT_OPEN_DRAIN 0x12
#define SPECIAL           0xF0
#define FUNCTION_1        0x00
#define FUNCTION_2        0x20
#define FUNCTION_3        0x40
#define FUNCTION_4        0x60
#define FUNCTION_5        0x80
#define FUNCTION_6        0xA0
#define ANALOG            0xC0
*/
