#include "RT_HW_Main.h"			//--RT_HW_14_String.cpp
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                 КОНСТРУКТОР
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
RT_HW_STRING:: RT_HW_STRING(){consoleReady=consoleUser=consoleParam=consoleEvent=false; consoleStep=0;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 			ФУНКЦИИ ДЛЯ РАБОТЫ С КОНСОЛЬЮ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool	 RT_HW_STRING:: consoleBegin(uint32_t speed){
switch(consoleStep){
	default:
	case 0: Serial.begin(speed); 	consoleTime=millis();  consoleStep++;
	case 1: if(!Serial) break;		
			//Serial.flush();
	        consoleReady=consoleUser=consoleParam=consoleEvent=true; 
			consoleWait=RT_HW_Task.getPastTense (consoleTime,millis());  
			consoleStep++; 
			break;
	case 2: consoleEvent=0; consoleStep++;
	case 3: return 1;}	
return 0;};// end initConsole()
//------------------
bool 	RT_HW_STRING:: consoleString (String mess,String head) 				 {if(consoleReady) if(head!="@") Serial.print(head); Serial.println(mess);   	return 1;};
bool 	RT_HW_STRING:: consoleInt16  (int32_t val,String head) 				 {if(consoleReady) if(head!="@") Serial.print(head); Serial.println(val);    	return 1;}
bool 	RT_HW_STRING:: consoleFloat  (float   val,String head,uint8_t point) {if(consoleReady) if(head!="@") Serial.print(head); Serial.println(val,point);	return 1;};	

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ФУНКЦИИ ДЛЯ ВЫБОРА ПАРАМЕТРОВ ИЗ СТРОКОВЫХ ПЕРЕМЕННЫХ 
//  (параметры разделяются запятыми, номера параметров начинается с 1)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//------------------------------------------------------------------------------------------------- 
//    Возвращает String. Если n=0 или значения нет, возвращает '*'.
//-------------------------------------------------------------------------------------------------
String	RT_HW_STRING:: getString(String val, uint8_t n) {String x; int16_t findPoint; uint8_t startPoint,endPoint, len,i; String s;
 startPoint=endPoint=findPoint=i=0;  s=val; len=val.length();
 x="";
 if(n==0) return x; else n--; //--Нормализация номера позиции для отсчета начиная с 1 
 do{if(i>n) break;
    if(startPoint>len) break;
	findPoint=val.indexOf(',', startPoint);   
	if (findPoint==-1) {endPoint=len;} else {endPoint=findPoint;}
	if (n==i) {s=val.substring(startPoint,endPoint); s.trim(); if(s=="") {break;} x=s; break;}  
	if (findPoint==-1)  break;
	startPoint=findPoint+1;	i++; 	
   } while (1);
return x;}
//---------------------------------------------------------------------------------------
//    Возвращает float. Если n=0 или значения нет, возвращает -NAN). Проверяет первый символ на '0...9', '+' и '-'
//---------------------------------------------------------------------------------------
float	RT_HW_STRING:: getFloat(String s, uint8_t n) {String t; 
 t= getString(s,n);
 if ((isdigit(t.charAt(0)) && (t.length()!=0)) || (t.charAt(0)=='-') || (t.charAt(0)=='+')) return t.toFloat(); else return NAN;}	
//------------------------------------------------------------------------------------------------- 
//    Возвращает int16_t. Если n=0 или значения нет, возвращает -32768. 
//   Если параметр negativeLimits='Y', отрицательные значения ограничиваются значением -1;
//-------------------------------------------------------------------------------------------------
int16_t	RT_HW_STRING:: getInt16(String s, uint8_t n){float x; 
x=getFloat(s, n); if (isnan(x)) x=-32768;  return x;}
//------------------------------------------------------------------------------------------------- 
//    Возвращает char. Если n=0 или значения нет, возвращает '*'.
//-------------------------------------------------------------------------------------------------
char	RT_HW_STRING:: getChar(String s, uint8_t n) {
 s= getString(s,n); 
 if(s.length()!=0) return s.charAt(0); else return '*'; }
//------------------------------------------------------------------------------------------------- 
//    Возвращает номер пина. Если n=0 или значения нет, возвращает -1) 
//-------------------------------------------------------------------------------------------------
int16_t RT_HW_STRING:: getPin(String v,uint8_t n){float x; 
x=getFloat(v, n); if((isnan(x)) || (x<0)) x=-1; return x;};
//------------------------------------------------------------------------------------------------- 
//    Возвращает номер пина или номер устройства (если нет =-1):
//    mode ='P' возвращает номер пина (от  -1 и выше).
//    	   ='D' возвращает номер устройства. Если n=0 или значения нет, возвращает -1) 
//-------------------------------------------------------------------------------------------------
int16_t RT_HW_STRING:: getDataFromString(String s,uint8_t n, char mode){float x;
	if (mode=='P') {x=getFloat(s, n); if((isnan(x)) || (x<0))  x=-1;} 						   //--здесь может появиться проверка корректности пина
	          else {x=getFloat(s, n); if (isnan(x)) x=-32768;  if((mode=='D') && (x<0)) x=-1;} //--здесь может появиться проверка корректности номера устройства
return x;}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   ФУНКЦИИ ДЛЯ ПОЛУЧЕНИЯ ФОРМАТИРОВАННЫХ СТРОКОВЫХ ПЕРЕМЕННЫХ 
//             (задается длина и тип выравнивания).
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//------------------------------------------------------------------------------------------------- 
//    Возвращает строку с n-пробелами
//-------------------------------------------------------------------------------------------------
String	RT_HW_STRING:: addBlank(uint8_t n)  {String s; s=""; for (uint8_t i=0; i<n; i++) {s=s+" ";} return s;};
//------------------------------------------------------------------------------------------------- 
//             ВЫРАВНИВАЕТ СТРОКУ 
//-------------------------------------------------------------------------------------------------
String	RT_HW_STRING:: formatString(String s, uint8_t len, char a) {uint16_t t; t=s.length();  
if(len>t){switch (a){
			default:
			case 'N': return s.substring(0,len);
			case 'L': return  					   (s.substring(0,len) + addBlank( len-t));    	
			case 'C': return (addBlank((len-t)/2) + s.substring(0,len) + addBlank((len-t)-((len-t)/2)));  
			case 'R': return (addBlank( len-t)    + s.substring(0,len));}}
return s;};
//------------------------------------------------------------------------------------------------- 
//             ВЫДАЕТ СТРОКУ C 4-МЯ ПЕРЕМЕННЫМИ ЗАДАННОЙ ДЛИНЫ a=N,L,C,R
//-------------------------------------------------------------------------------------------------
String RT_HW_STRING:: packFourFloat(float v1, float v2, float v3, float v4, char a, uint8_t len, uint8_t m){
return (formatString(String(v1,m),len,a) +formatString(String(v2,m),len,a) +formatString(String(v3,m),len,a) +formatString(String(v4,m),len,a));}	
//------------------------------------------------------------------------------------------------- 
//             ВЫДАЕТ СТРОКУ C 4-МЯ ПЕРЕМЕННЫМИ, разделенных запятыми
//-------------------------------------------------------------------------------------------------
String RT_HW_STRING:: packFourInt16(int16_t v1, int16_t v2, int16_t v3, int16_t v4, char a, uint8_t len) { 
return (formatString(String(v1),len,a) + formatString(String(v2),len,a) + formatString(String(v3),len,a) + formatString(String(v4),len,a));}	

//------------------------------------------------------------------------------------------------- 
//             ВЫДАЕТ СТРОКУ C 4-МЯ ПЕРЕМЕННЫМИ, разделенных запятыми
//-------------------------------------------------------------------------------------------------
String RT_HW_STRING:: packInt16(String head, char a,uint8_t len,uint8_t qnt,int16_t v1,int16_t v2,int16_t v3,int16_t v4,int16_t v5,int16_t v6,int16_t v7,int16_t v8) { String mess;
if(head!="@") {mess=head+formatString(String(v1),len,a);} 
else   mess=formatString(String(v1),len,a); if(qnt<=1) return mess;
mess= mess+formatString(String(v2),len,a); if(qnt<=2) return mess;
mess= mess+formatString(String(v3),len,a); if(qnt<=3) return mess;
mess= mess+formatString(String(v4),len,a); if(qnt<=4) return mess;
mess= mess+formatString(String(v5),len,a); if(qnt<=5) return mess;
mess= mess+formatString(String(v6),len,a); if(qnt<=6) return mess;
mess= mess+formatString(String(v7),len,a); if(qnt<=7) return mess;
mess= mess+formatString(String(v8),len,a); 
return mess;}	


//---------------------------------------------------------------------------------------
//                           СОЗДАНИЕ ОБЪЕКТА 
//---------------------------------------------------------------------------------------
RT_HW_STRING   RT_HW_String;
//=======================================================================================
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++