#include "RT_HW_Main.h"		// RT_HW_21_Task.cpp
//---------------------------------------------------------------------------------------
//						КОНСТРУКТОР
//---------------------------------------------------------------------------------------
RT_HW_TASK:: RT_HW_TASK() {						
	step=0;  init=user=begin=reset=permit=false;  fast10=fast=slow=back=back100=false;
	periodFast=25000UL; periodSlow=250000UL;
	init=user=true; };	
//---------------------------------------------------------------------------------------
//         ФУНКЦИИ РАБОТЫ С ВРЕМЕНЕМ И uint32_t (с учетом переполнения uint32_t
//	getT2subT1:     Входное условие: t2>=t1; Возвращает разницу между t2-t1 с учетом переполнения
//  checkPastTense: Возвращает true, если ((t2-t1) >= val). Изспользуется ДИСПЕТЧЕРОМ ЗАДАЧ
//
//--------------------------------------------------------------------------------------- 
uint32_t RT_HW_TASK::  getPastTense (uint32_t &t1,uint32_t t2)              {if(t2>=t1){return (t2-t1);}                else {return (0xFFFFFFFF-t1+t2);}}; 
bool     RT_HW_TASK::checkPastTense (uint32_t &t1,uint32_t t2,uint32_t val) {if(t2>=t1) {if((t2-t1)>=val) return true;} else {if ((0xFFFFFFFF-t1+t2)>=val) return true;} return false;};   
bool 	 RT_HW_TASK::checkPastMicros(uint32_t &t1,uint32_t val) {t2=micros();if(t2>=t1) {if((t2-t1)>=val) return true;} else {if ((0xFFFFFFFF-t1+t2)>=val) return true;} return false;}; 
bool 	 RT_HW_TASK::checkPastMillis(uint32_t &t1,uint32_t val) {t2=millis();if(t2>=t1) {if((t2-t1)>=val) return true;} else {if ((0xFFFFFFFF-t1+t2)>=val) return true;} return false;}; 
bool     RT_HW_TASK::period(RT_HW_TASK_TIME_ID &id,uint32_t val,bool mcs){
		 switch(id.step){default:
			 case 0:		  			   id.step++;
			 case 1:if(id.mcs) id.timeBegin=micros(); else id.timeBegin=millis(); id.step++;
			 case 2:if(id.mcs) {if(checkPastMicros(id.timeBegin, val)) {id.step=0; return 1;} else return 0;} 
						 else  {if(checkPastMillis(id.timeBegin, val)) {id.step=0; return 1;} else return 0;} 
		 };
};	
//---------------------------------------------------------------------------------------
//         ФУНКЦИИ КОНТРОЛЯ ИЗМЕНЕНИЯ ПАРАМЕТРОВ
//--------------------------------------------------------------------------------------- 
bool 	 RT_HW_TASK::changeByte	 (uint8_t  valAgo, uint8_t  val) {if(valAgo!=val){valAgo=val;	return 1;} else return 0;}; 
bool 	 RT_HW_TASK::changeInt16 (uint16_t valAgo, uint16_t val) {if(valAgo!=val){valAgo=val;	return 1;} else return 0;};
bool 	 RT_HW_TASK::changeFloat (float    valAgo, float    val) {if(valAgo!=val){valAgo=val;	return 1;} else return 0;};
bool 	 RT_HW_TASK::changeString(String   valAgo, String   val) {if(valAgo!=val){valAgo=val;	return 1;} else return 0;};
//---------------------------------------------------------------------------------------
//						ДИСПЕТЧЕР ЗАДАЧ 
// (генерит init длительностью 20mcs (для сброса внешних устройств, задач) 
// и через 100mcs устанавливает permit (разрешение внешних устройств, задач)
//---------------------------------------------------------------------------------------
bool RT_HW_TASK:: run() {
	control=!control; fast=slow=back=fast10=back100=false;
switch (step){
default: step=0;
	case 0: timeBeginBack100=millis(); step++;		
	case 1: if(checkPastTense(timeBeginBack100, millis(),10)) 							    	step++;	return 0;
	case 2: 														   			reset=true; 	step++;	return 0;
	case 3:					  timeBeginBack100= millis();				 		reset=false;	step++;	return 0;
	case 4:	if(checkPastTense(timeBeginBack100, millis(), 2)) {permit=true; timeBeginFast=timeBeginSlow=timeBeginFast10=timeBeginBack100=0; step++;}	return 0;
	case 5: if(checkPastTense (timeBeginFast10,	micros(),      10000)) {timeBeginFast10 +=10000;	fast10= true; 	return 1;} 	
			if(checkPastTense (timeBeginFast, 	micros(), periodFast)) {timeBeginFast+=periodFast;	fast=   true; 	return 1;} 					
			if(checkPastTense (timeBeginSlow, 	micros(), periodSlow)) {timeBeginSlow+=periodSlow;	slow=   true; 	return 1;}
			if(checkPastTense (timeBeginBack100,micros(),     100000)) {timeBeginBack100+=100000;	back100=true; 	return 1;} 																														back   =true;	return 1;} return 1;}
//---------------------------------------------------------------------------------------
//						ГЕНЕРАТОР СОБЫТИЙ
//---------------------------------------------------------------------------------------
void RT_HW_TASK:: generator(RT_HW_TASK_GENERATOR_ID &id, bool extEvent, uint8_t qnt, uint8_t On) {
if(!id.init) {id.init=true; id.task=id.work=0; id.event=id.pulse=false;}
	id.task=0; id.event=false;  
    if(extEvent) {id.work++; if(id.work > qnt) {id.work=1; id.event=true;} id.task=id.work; 
	if(On >=id.work) id.pulse=true; else id.pulse=false;}
};		
//---------------------------------------------------------------------------------------
//							СЧЕТЧИК
//---------------------------------------------------------------------------------------
void RT_HW_TASK:: setCounterID(RT_HW_TASK_COUNTER_ID &id, char mode, int16_t delta, int16_t top, int16_t bottom, int16_t begin){
	if(id.init) return;
	id.init=id.user=id.direct=true; id.mode=mode; id.top=top; id.bottom=bottom; id.cnt=begin;
	id.delta=delta; if(id.mode=='T') {if(id.delta<0)  {id.direct=true; id.delta=-id.delta;} else id.direct=false;}	
};
//---------------------------------------------------------------------------------------
//							СЧЕТЧИК
//---------------------------------------------------------------------------------------
void RT_HW_TASK:: counter(RT_HW_TASK_COUNTER_ID &id){
	if(!id.init) return;
	switch( id.mode ) {
	default: //-----неизвестный режим - будет отрабатывать режим S
	 case 'S':	if(id.delta>0) {if(id.cnt==id.top)    {id.cnt=id.bottom;} else {id.cnt=id.cnt+id.delta; if (id.cnt>id.top)    {id.cnt=id.top;   }}} //пила+:увеличение до верхней границы с возвратом к нижней границе
				if(id.delta<0) {if(id.cnt==id.bottom) {id.cnt=id.top;}    else {id.cnt=id.cnt+id.delta; if (id.cnt<id.bottom) {id.cnt=id.bottom;}}} //пила-:уменьшение до нижней  границы с возратом  к верхней границе
				break;
	case 'T':	if(id.cnt==id.top) 	  id.direct=false; 
				if(id.cnt==id.bottom) id.direct=true;
                if(id.direct==true) {id.cnt=id.cnt+id.delta; if (id.cnt>id.top) 	id.cnt=id.top;}
                              else  {id.cnt=id.cnt-id.delta; if (id.cnt<id.bottom)  id.cnt=id.bottom;} 
				break;
	 case 'L':  if(id.delta>0) {id.cnt=id.cnt+id.delta; if (id.cnt>id.top)    id.cnt=id.top;}       //предел+: увеличение до верхней границы;
				if(id.delta<0) {id.cnt=id.cnt+id.delta; if (id.cnt<id.bottom) id.cnt=id.bottom;}    //предел-: уменьшение до нижней  границы;
				break; 
	 case 'C':  id.cnt=id.cnt+id.delta;  
				if(id.delta>0) {if(id.cnt>  32767) id.cnt= 32767;}
				if(id.delta<0) {if(id.cnt< -32768) id.cnt=-32768;}
				break; //------  0-  изменение+ :   увеличение без ограничения (int);						
}}
//--------------------------------------------------------------------------------------- 
//                           СОЗДАНИЕ ОБЪЕКТА 
//---------------------------------------------------------------------------------------
RT_HW_TASK  RT_HW_Task;


