*** FLProg ************** 
 
/****************************************************************************************
 							 BOARD 
-----------------------------------------------------------------------------------------


struct RT_HW_STRUCT_BOARD {
	uint8_t  allow:1, init:1;
	uint8_t  code;   String name;
    int16_t  ledControl;    int16_t digitalPins; int16_t analogPins; 
	uint16_t i2c:1, wifi:1, spi:1, mqtt:1, lcd_hd44780:1, dht:1, ds1820:1, hc_sr04:1;
    enum {NO=0, ALLOW, INIT, CODE, NAME, LED_CONTROL, DIGITAL_PINS, ANALOG_PINS,
         I2C, WIFI, SPI, LCD_HD44780, DHT, DS1820, HC_SR04};};
struct RT_HW_STRUCT_BOARD -структура данных конфигурация контроллера (примерно 22 байт): 
	allow - флаг разрешения(=1) c платой; init -флаг инициал. библиотек (=1); 
	code -код платы; name -имя платы;
	ledControl - номер пина контрольного светодиода; 
	numDigitalPins - кол-во дискретных входов; numAnalogPins кол-во аналоговых входов;
	wdog,i2c,wifi,spi,mqtt, modbus,lcd_hd44780,dht,ds1820,hc_sr04 - флаги подключаемых библиотек;
	enum {ИМЕНА с заглавными буквами} для доступа к параметрам в  методах;
RT_HW_board_begin() - инициализация
RT_HW_board_set(name,mode,v) -установка значение v в параметр name. 
        Возвращает значение параметра. Если mode==0, установка значения пропускается. 
RT_HW_board_get() -возвращает параметры через структуру.		
----------------------------------------------------------------------------------------- 
RT_HW_DEFINED_XXXX - глобальный макрос, наличие которого означает тип используемого контроллера,
   где XXXX -AVR328,MEGA2560,SAM32X8E (это Arduino DUE), ESP8266, ESP32, STM32, ANON
RT_HW_CODE_BOARD  - глобальный макрос, код платы в соответствии с внешним перечислением RT_CODE_XXXX. 
RT_HW_NAME_BOARD  - глобальный макрос, имя платы   
LED_BUILTIN		  - системный макрос номер пина контрольного светодиода
NUM_DIGITAL_PINS  - системный макрос кол-во пинов в контроллере
NUM_ANALOG_INPUTS - системный макрос кол-во аналоговых входов в контроллере
****************************************************************************************/ 
 
**************************************************************************************************
/*** FLProg ************** Библиотека RT_Hardware.h ver5.1 для Arduino ***************

  Библиотека создана и будет развиваться для обеспечения совместимости библиотек серии RT
  и пользовательских программ   на контроллерах AVR, ESP8266, ESP32, STM32.
  Дополнительно библиотека реализует ряд удоюбных функция для работы реального времени
 
  Возможности библиотеки:
  МАКРОСЫ:
  RT_HARDWARE_NUMBER_VER 	- номер версии библиотеки
  RT_HARDWARE_BOARD_TYPE				- тип контроллера: =0 - контроллер не опознан; =1 -AVR; =2 -ESP8266; =3 -ESP32; =4 -STM32.
  RT_micros					- возращает  текущее время микросекундах
  RT_millis 				- возвращает текущее время в миллисекундах
  RT_delay_mcs(t)			- задержка в мкс 		
  RT_delay_ms(t) 			- задержка в мс
  
  ГЛОБАЛЬНЫЕ ФУНКЦИИ:
  RT_getPastTense   (t1,t2) - возвращает разницу во времени (t2-t1).
  RT_checkPastTense (t1, t2, val) - фиксирует событие по времени(однократным импульсом) (t2-t1)>=period 
  RT_periodMicros   (&t1, val)    - генератор коротких импульсов с периодом val в мкс: t1 - рабочая переменная (uint32_t)
  RT_periodMillis   (&t1, val)    - генератор коротких импульсов с периодом val в мс:  t1 - рабочая переменная (uint32_t)
  RT_delayMicros    (&step, &start, val) - задержка по времени val в мкс: step(bool), start(uint32_t) - рабочие переменные	
  RT_delayMillis    (&step, &start, val) - задержка по времени val в мс:  step(bool), start(uint32_t) - рабочие переменные			
  
  КЛАСС ДЛЯ ПОТОКОВОГО УПРАВЛЕНИЯ (ДИСПЕТЧЕР ЗАДАЧ)
  RT_Sheduler xxx;
  xxx.run()- запуск диспетчера задач
  xxx.setFast(qnt, period) - установка кол-ва быстрых   задач (max=31) и периода их вызова (max=60000мс). По умолчанию: 5, 25
  xxx.setSlow(qnt, period) - установка кол-ва медленных задач (max=31) и периода их вызова (max=60000мс). По умолчанию: 4,250
  xxx.setBack(qnt, period) - установка кол-ва фоновых задач   (max=31). Второй параметр не учитывается.   По умолчанию: 4,  0  
  xxx.Fast.qnt - кол-во быстрых задач
  xxx.Slow.qnt - кол-во медленных задач
  xxx.Back.qnt - кол-во фоновых задач
  xxx.Fast.num - номер вызываемой быстрой задачи
  xxx.Slow.qnt - номер вызываемой медленной задачи
  xxx.Back.qnt - номер вызываемой фоновой задачи
  xxx.init - импульс (может быть использован для инициализации внешних устройств)
  xxx.permit-сигнал разрешения работы внешних устройств (устанавливается после имульса инициализации)
  xxx.control-меняет значение на противоположное (false/true) при каждом вызове функции xxx.run()
              Может быть использован для наблюдения за непрерыностью потоковых процессов логическим анализатором
  xxx.initUser-сервисная переменная для пользователя. При определении объекта =false
  
    * Импульс - это сигнал, который сбрасывается при следующем вызове функции xxx.run()
	** При каждом вызове диспетчера только один номер задачи не равен нулю со следующим приоритетом: Fast, Slow, Back
	*** В начале каждого цикла инвентируется флаг control
	**** В начале каждого цикла сбрасываются все номера задач - Fast.num=Slow.num=Back.num=0. 
	
	1. После включения пауза 250 мкс. Затем устанавливается сигнал init
    2. В следующем цикле init сбрасывается.
	3. После паузы 100 мкс устанавливается сигнад permit (разрешение работы)
	4. В следующем цикле устанавливается Fast.num=1; 
	5. В следующем цикле устанавливается Slow.num=1; 
	6. Цикл инициализации временных параметров (для точного старта отсчета времени периодов)
	7. Далее заданной периодичностью меняются номера быстрых, медленных и фоновых задач.
	   В каждом цикле взводится только один из номеров задач с приоритетом: быстрые, медленные, фоновые.
	   Этап 7 повторяется бесконечно до перезапуска контроллера.
	   
	*** Время цикла диспетчера задач примерно 22мкс для процессора типа ATmega328(16мГц) и 7мкс для ESP8266(40мГц) 
			  
**************************************************************************************************/

/****************************************************************************************
                           ИНТЕРФЕЙС i2c
-----------------------------------------------------------------------------------------						   
struct RT_HW_STRUCT_I2C -структура данных для работы с шиной i2c(размер 10 байт)
     allow - флаг разрешения(=1) работы с шиной; init -флаг инциал.шины (=1);
	 busy -флаг занятости(=1) шины; 
     sda -номер пина SDA; scl -номер пина SCL, 
     freq - частота шины в кГц, limit - параметр stretchClockLimit (рекомендуется для ESP8266=230) 
	enum {ИМЕНА с заглавными буквами} для доступа к параметрам в  методах;
RT_HW_i2c_begin() - инициализация
RT_HW_i2c_set(name,mode,v) -установка значение v в параметр name. 
        Возвращает значение параметра. Если mode==0, установка значения пропускается. 
RT_HW_i2c_get() -возвращает параметры через структуру.	
RT_HW_i2c_scan(String &S, uint8_t time) - возвращает кол-во найденных устройств и их
                  адреса в текстовой строке S. Если шина не инициирована, возвращает -1.                                           
****************************************************************************************/