//Тест MCP23017
#include "RT_HW_Main.h"
#include "RT_HW_MCP23017.h" //Включает #include "RT_HW_Wire.h"

RT_HW_MCP23017_ID     idMCP;
RT_HW_PIN_DIGITAL_ID  idControl,  idNoFind, idLink, idDevice;
RT_HW_TASK_TIME_ID    idTime1,    idTime2,  idTime3;
RT_HW_TASK_COUNTER_ID idCnt1,     idCnt2;     
int16_t addrMCP=0x20; //0x20 шестнадцатиричный или 32 десятичный
bool bl;
byte direct=0;
//byte agoInA,agoInB;
bool flPrint;
bool firstPrint;
void printInput(){Serial.println("device="+ String(idMCP.device)+" inA="+String(idMCP.inA,HEX)+" inB="+String(idMCP.inB, HEX));}
//---------------------------------------
void setup(){Serial.begin(115200);
}
//---------------------------------------
void loop() {
//------Вывод на пины контрольных сигналов ------------------
bl=!bl;
RT_HW_Board.pinDigitalWriteID(idControl,13,bl); //--Вывод сигнала "Контроль"
RT_HW_Board.pinDigitalWriteID(idNoFind, 12,idMCP.noFind);     //--Вывод сигнала "Устройство не обнаружено"
RT_HW_Board.pinDigitalWriteID(idLink,   11,idMCP.link);       //--Вывод сигнала "Есть связь"
RT_HW_Board.pinDigitalWriteID(idDevice, 10,idMCP.device);     //--Вывод сигнала "Есть связь"
//----- Инициализация консоли. Работает в фоновом режиме----
RT_HW_Console.begin(115200);   //--Функция ожидает готовность консоли, потом ничего                      
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//     ИНИЦИАЛИЗАЦИЯ ПАРАМЕТРОВ ОБЪЕКТОВ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if(direct==0) {direct=1;
if(!idMCP.init) {RT_HW_mcp23017.setID (idMCP,addrMCP, 7, 0);}
if(!idCnt1.init){RT_HW_Task.setCounterID(idCnt1, 'S',1,255,0);}
if(!idCnt2.init){RT_HW_Task.setCounterID(idCnt2, 'T',1,255,0);}
}  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//     ИЗМЕНЕНИЕ ДАННЫХ ДЛЯ ЗАПИСИ В УСТРОЙСТВО
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if(RT_HW_Task.period(idTime1, 250)) {RT_HW_Task.counter(idCnt1); idMCP.outA=idCnt1.cnt; RT_HW_Task.counter(idCnt2); idMCP.outB=idCnt2.cnt; idMCP.run=1;}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                    ОБМЕН С УСТРОЙСТВОМ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
RT_HW_mcp23017.device(idMCP);
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                   ВЫВОД НА КОНСОЛЬ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if(RT_HW_Console.ok) {
 //----ВЫВОД ОДНОРАЗОАОГО СООБЩЕНИЧ 
  if(!firstPrint) {firstPrint=1; 
      Serial.println("Test mcp23017 addres=" + String(idMCP.addr) + "/0x" + String(idMCP.addr,HEX)); 
      Serial.println("regA=" + RT_HW_String.packFourInt16 (0, idMCP.gppuA, idMCP.ipolA, idMCP.dirA, 'R', 2)); 
      Serial.println("regB=" + RT_HW_String.packFourInt16 (0, idMCP.gppuB, idMCP.ipolB, idMCP.dirB, 'R', 2));
      printInput();}
 //--- ВЫВОД СООБЩЕНИЙ ПРИ ИЗМЕНЕНИИ ВХОДОВ
if(RT_HW_mcp23017.checkInA(idMCP)||RT_HW_mcp23017.checkInB(idMCP) || RT_HW_mcp23017.checkDevice(idMCP)){printInput();};
} 
//-------------------------------------------
} // end loop()
//==========================================
